// 013 u_c_create_ib_table
// 25 mar 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_create_ib_table;
  interface
    uses Classes, DbTables, u_c_basic_object
        , IbQuery;

    type c_create_ib_table= class(c_basic_object)
                              m_table_name: String;
                              m_c_ib_query_ref: tIbQuery;
                              m_c_fields: tStringList;
                              m_exec_sql: Boolean;

                              Constructor create_ib_table(p_name, p_table_name: String;
                                  p_c_ib_query: tIbQuery);
                              procedure drop_table;
                              procedure create_table;
                              procedure display_sql;
                              Destructor Destroy; Override;
                            end; // c_create_ib_table

  implementation
    Uses SysUtils, u_c_display;

    // -- c_create_ib_table

    Constructor c_create_ib_table.create_ib_table(p_name, p_table_name: String;
        p_c_ib_query: tIbQuery);
      begin
        Inherited create_basic_object(p_name);

        m_table_name:= p_table_name;
        m_c_ib_query_ref:= p_c_ib_query;

        m_c_fields:= tStringList.Create;
      end; // create_ib_table

    procedure c_create_ib_table.display_sql;
      var l_field_index: Integer;
      begin
        display('CREATE TABLE '+ m_table_name+ ' (');
        for l_field_index:= 0 to m_c_fields.Count- 2 do
          display(m_c_fields[l_field_index]+ ',');
        display(m_c_fields[m_c_fields.Count- 1]+ ' )');
      end; // display_sql

    procedure c_create_ib_table.drop_table;
      begin
        display('drop '+ m_table_name);

        with m_c_ib_query_ref, Sql do
        begin
          Clear;
          Add('DROP TABLE '+ m_table_name);
          display_strings(Sql);

          Try
            ExecSql;
            display('  ok_dropped');
          Except
            display('  *** pb_drop');
          end;
        end; // with m_c_ib_query_ref
      end; // drop_table

    procedure c_create_ib_table.create_table;
      var l_field_index: Integer;
      begin
        drop_table;

        with m_c_ib_query_ref, Sql do
        begin
          display(m_table_name);
          Clear;

          Add('CREATE TABLE '+ m_table_name+ ' (');
          for l_field_index:= 0 to m_c_fields.Count- 2 do
            Add(m_c_fields[l_field_index]+ ',');
          Add(m_c_fields[m_c_fields.Count- 1]+ ' )');
          // display_strings('', Sql);

          display_strings(Sql);

          if m_exec_sql
            then
              try
                if DataBase.DefaultTransaction.InTransaction
                  then DataBase.DefaultTransaction.Commit;
                DataBase.DefaultTransaction.StartTransaction;
                ExecSql;
                DataBase.DefaultTransaction.Commit;

                display('  ok '+ m_table_name);
              except
                on e: Exception do
                   display('  *** pb_create '+ e.Message);
              end // try ... Except
            else display('did_not_ask_to_create');
        end; // with m_c_ib_query_ref, Sql
      end; // create_table

    Destructor c_create_ib_table.Destroy;
      begin
        m_c_fields.Free;
        Inherited;
      end; // Destroy

    begin // u_c_create_ib_table
    end. // u_c_create_ib_table
