// 013 u_ib_create_tables_with_script
// 25 mar 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com


(*$r+*)
unit u_ib_create_tables_with_script;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  IBCustomDataSet, IBQuery, IBDatabase, IBTable;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    IBDatabase1: TIBDatabase;
    Panel1: TPanel;
    Memo1: TMemo;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    create_script_: TButton;
    display_schema_: TButton;
    display_script_: TButton;
    formations_: TButton;
    dates_: TButton;
    villes_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure create_script_Click(Sender: TObject);
    procedure display_schema_Click(Sender: TObject);
    procedure display_script_Click(Sender: TObject);
    procedure formations_Click(Sender: TObject);
    procedure dates_Click(Sender: TObject);
    procedure villes_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    , u_c_create_ib_table
    ;

    {$R *.DFM}

 
    const k_root_path= '..\data\';
          k_script_path= k_root_path;
            k_script_name= 'schema_simple.txt';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.create_script_Click(Sender: TObject);
      const k_exec_sql= [0, 1, 2];
            // k_exec_sql= [];
      var l_list_index: Integer;
          l_line, l_trimmed_line: String;
          l_c_create_ib_table: c_create_ib_table;
          l_table_index: Integer;
      begin
        with tStringList.Create do
        begin
          LoadFromFile(k_script_path+ k_script_name);
          l_c_create_ib_table:= Nil;

          l_table_index:= 0;

          for l_list_index:= 0 to Count- 1 do
          begin
            l_line:= Strings[l_list_index];
            // display(l_line);
            l_trimmed_line:= Trim(l_line);
            if l_trimmed_line<> ''
              then begin
                  if l_trimmed_line= l_line
                    then begin
                        if Assigned(l_c_create_ib_table)
                          then begin
                              l_c_create_ib_table.create_table;
                              l_c_create_ib_table.Free;
                              Inc(l_table_index);
                            end;

                        display_line;
                        display('go_create '+ l_trimmed_line);
                        l_c_create_ib_table:= c_create_ib_table.create_ib_table('', l_line, IbQuery1);
                        l_c_create_ib_table.m_exec_sql:= l_table_index in k_exec_sql;
                      end
                    else begin
                        l_c_create_ib_table.m_c_fields.Add(l_trimmed_line);
                      end;
                end;
          end; // for l_list_index

          if Assigned(l_c_create_ib_table)
            then begin
                l_c_create_ib_table.create_table;
                l_c_create_ib_table.Free;
              end;

          Free;
        end; // with tStringList
      end; // create_script_Click

    procedure TForm1.display_schema_Click(Sender: TObject);
      var l_c_string_list: tStringList;
      begin
        l_c_string_list:= tStringList.Create;
        with l_c_string_list do
        begin
          LoadFromFile(k_script_path+ k_script_name);
          display_strings(l_c_string_list);
          Free;
        end; // with tStringList
      end; // display_schema_Click

    procedure TForm1.display_script_Click(Sender: TObject);
      const k_exec_sql= [0, 1, 2];
      var l_c_create_ib_table: c_create_ib_table;
          l_table_index: Integer;

      procedure create_the_table;
        begin
          if Assigned(l_c_create_ib_table)
            then begin
                l_c_create_ib_table.display_sql;
                l_c_create_ib_table.Free;
                Inc(l_table_index);
              end;
        end; // create_the_table

      var l_list_index: Integer;
          l_line, l_trimmed_line: String;

      begin // display_script_Click
        with tStringList.Create do
        begin
          LoadFromFile(k_script_path+ k_script_name);

          l_table_index:= 0;
          l_c_create_ib_table:= Nil;

          for l_list_index:= 0 to Count- 1 do
          begin
            l_line:= Strings[l_list_index];
            // display(l_line);
            l_trimmed_line:= Trim(l_line);
            if l_trimmed_line<> ''
              then begin
                  if l_trimmed_line= l_line
                    then begin
                        // -- do create the previous table
                        create_the_table;

                        display_line;
                        l_c_create_ib_table:= c_create_ib_table.create_ib_table('', l_line, IbQuery1);
                        l_c_create_ib_table.m_exec_sql:= l_table_index in k_exec_sql;
                      end
                    else begin
                        l_c_create_ib_table.m_c_fields.Add(l_trimmed_line);
                      end;
                end;
          end; // for l_list_index

          // -- flush the last table
          create_the_table;
        end; // with tStringList.Create
      end; // display_script_Click

    // -- check creation

    procedure TForm1.formations_Click(Sender: TObject);
      begin
        display('Select * from formations');

        with IbQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('Select * from formations');
            Open;
          end; // with Sql
        end; // with IbQuery1
      end; // formations_Click

    procedure TForm1.dates_Click(Sender: TObject);
      begin
        display('Select * from dates');

        with IbQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('Select * from dates');
            Open;
          end; // with Sql
        end; // with IbQuery1
      end; // dates_Click

    procedure TForm1.villes_Click(Sender: TObject);
      begin
        display('Select * from villes');

        with IbQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('Select * from villes');
            Open;
          end; // with Sql
        end; // with IbQuery1
      end; // villes_Click

end.


